/*
 * hd44780.c
 *
 *  Created on: Jan 26, 2022
 *      Author: PC
 */

#include "main.h"
#include "../def.h"
#include "hd44780.h"




uint8_t lcdRow, lcdLine;
#if defined(LCDMIROR) || defined(LCDIRQ)
char LCDtabMiror[LCDLINE][LCDROW];
#endif


__STATIC_INLINE void Delay_us(volatile uint16_t microseconds)
{
	TIM7->CNT = 0;	// Zerowanie preskalera
	TIM7->CNT = 0;
	while ( TIM7->CNT  < microseconds) __NOP();

	/*
__STATIC_INLINE void Delay_us(volatile uint16_t microseconds)
{
  uint32_t clk_cycle_start = DWT->CYCCNT;

  // Go to number of cycles for system //
  microseconds *= (HAL_RCC_GetHCLKFreq() / 1000000);

  // Delay till end //
  while ((DWT->CYCCNT - clk_cycle_start) < microseconds);
	 */
}


//-----------------------------------------------------------------
void LcdClr()
{

#ifndef LCDIRQ
	LcdSendCommand(0x1);
	LcdHome();						// "LcdHome()" zeruje "lcdRow" i "lcdLine"
#endif

	//	for(r=0; r<8; r++) tabChar[r]=0;// Czysci tablice dynamicznych znaków


#if defined(LCDMIROR) || defined(LCDIRQ)
	uint8_t r,l;
	for(r=0;r<LCDROW; r++)		// Czysci wirtualny wyswietlacz
		for(l=0; l<LCDLINE; l++)
			LCDtabMiror[l][r] = ' ';
#endif
}


void LcdHome(){
#ifndef LCDIRQ
	LcdSendCommand(0x2);
#endif
	lcdRow=0; lcdLine=0;
}


void LcdSendNible(unsigned char data){
	//	LcdD0clr; LcdD1clr; LcdD2clr; LcdD3clr;	// Nieuzywane linie do masy
	if ((data & 1) != 0) LcdD4set; else LcdD4clr;
	if ((data & 2) != 0) LcdD5set; else LcdD5clr;
	if ((data & 4) != 0) LcdD6set; else LcdD6clr;
	if ((data & 8) != 0) LcdD7set; else LcdD7clr;
	Delay_us(DELAYLCD);
	LcdEset;								// E=1
	Delay_us(DELAYLCD);
	LcdEclr;								// E=0
#ifndef LCDIRQ
	Delay_us(DELAYLCD);
#endif
}


bool flLcdRun;
uint8_t flCmd;
//-----------------------------------------------------------------
void lcdDataPut_IT(){
#ifdef LCDIRQ
	uint8_t static line, row;

	if( ! flLcdRun ) return;

	LcdSendData_IT( LCDtabMiror[line][row++] );

	//poniższe zamazuje wysłany zna do LCD dlatego wyświetlacz ma sztucznie zwiększoną rozzielczość poziomą (będzi problem na 2X40 I 4X20)
	if ( row > LCDROW ){
	//if ( row >= LCDROW ){
		row=0; line++;
		uint8_t row = 0x40;
		row |= 0x80;					// Kod rozkazu ($80) OR pozycja w RAM LCD
		flCmd = row;
		LcdSendCommand_IT(row);
		if ( line >= LCDLINE ) {
			line=0;
			flCmd = 0x80;
			LcdSendCommand_IT(0x80);	// 0,0 szybsze niż HOME
		}
	};
#endif
}


uint8_t volatile lcdByteWr, lcdKrokWr;
//void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim){
//	if( htim == &htim7 ){
// PSC=31 (1us), ARR 65536
//		extern void lcd_us();
//		lcd_us();
//	}
//}
void lcd_us(){
#ifdef LCDIRQ

	if( ! flLcdRun ) return;


	switch( lcdKrokWr ){
/*
	 	case 0:
		//if( ! flCmd )
			lcdDataPut_IT();
		lcdKrokWr++;
		LcdEset;								// E=1
		break;
	case 1:
		LcdEclr;								// E=0
		lcdKrokWr++;
		break;
	case 2:
		LcdSendNible_IT( lcdByteWr );
		lcdKrokWr++;
		LcdEset;								// E=1
		break;
	case 3:
		LcdEclr;								// E=0
	 //		if( flCmd ){
//			LcdSendCommand_IT( flCmd );
//			flCmd = 0;
//		}else
		{
			if( ! LcdRS_Rd ){
				if ( (lcdByteWr & 1) == 1 ) TIM7->ARR = 1520; 		// LcdCls 1,5ms
				else if ( (lcdByteWr & 2) == 2 ) TIM7->ARR = 1520;	// LcdHome 1,5ms
				else TIM7->ARR = 1000;								// Pozostale rozkazy 40us
			} else TIM7->ARR = 1000;
		}

		lcdKrokWr = 0;
	 break;
	 */
	case 0:
		//if( ! flCmd )
			lcdDataPut_IT();
		lcdKrokWr++;
		break;
	case 1:
		LcdEset;								// E=1
		lcdKrokWr++;
		break;
	case 2:
		LcdEclr;								// E=0
		lcdKrokWr++;
		break;
	case 3:
		LcdSendNible_IT( lcdByteWr );
		lcdKrokWr++;
		break;
	case 4:
		LcdEset;								// E=1
		lcdKrokWr++;
		break;
	case 5:
		LcdEclr;								// E=0
		lcdKrokWr++;
		break;
	case 6:
//		if( flCmd ){
//			LcdSendCommand_IT( flCmd );
//			flCmd = 0;
//		}else
		{
			if( ! LcdRS_Rd ){
				if ( (lcdByteWr & 1) == 1 ) TIM7->ARR = 1520; 		// LcdCls 1,5ms
				else if ( (lcdByteWr & 2) == 2 ) TIM7->ARR = 1520;	// LcdHome 1,5ms
				else TIM7->ARR = 40;								// Pozostale rozkazy 40us
			} else TIM7->ARR = 2500;
		}
		lcdKrokWr = 0;
		break;

	}
#endif
}


void LcdSendNible_IT(unsigned char data){
	if ((data & 1) != 0) LcdD4set; else LcdD4clr;
	if ((data & 2) != 0) LcdD5set; else LcdD5clr;
	if ((data & 4) != 0) LcdD6set; else LcdD6clr;
	if ((data & 8) != 0) LcdD7set; else LcdD7clr;
}


void LcdSendData_IT(unsigned char data){
	//	LcdDataOut();
	LcdRSset;								// RS=1

	LcdSendNible_IT( data >> 4 );

	lcdByteWr = data;
	lcdKrokWr = TIM7->CNT = 0;
	TIM7->ARR = DELAYLCD;
}


void LcdSendCommand_IT(unsigned char data){
	LcdRSclr;								// RS=0;

	LcdSendNible_IT( data >> 4 );

	lcdByteWr = data;
	lcdKrokWr = TIM7->CNT = 0;
	TIM7->ARR = DELAYLCD;
}


//-----------------------------------------------------------------
void LcdSendCommand(unsigned char data){
	LcdRSclr;								// RS=0;
#ifdef LCD8BIT
	LcdSendByte( data );
#else
	LcdSendNible( data >> 4 );  			// Starsze 4 bity
	LcdSendNible( data ); 		 			// Mlodsze 4 bity
#endif
	//--- Oczekiwanie na zakonczenie operacji ---
	if ( (data & 1) == 1 ) Delay_us(1520); 		// LcdCls 1,5ms
	else if ( (data & 2) == 2 ) Delay_us(1520); // LcdHome 1,5ms
	else Delay_us(40);							// Pozostale rozkazy 40us
}


void LcdSendData(unsigned char data){
	//	LcdDataOut();
	LcdRSset;								// RS=1
#ifdef LCD8BIT
	LcdSendByte( data );
#else
	LcdSendNible( data >> 4 );  			// Starsze 4 bity
	LcdSendNible( data ); 		 			// Mlodsze 4 bity
#endif
}


void LcdSetCursorPosition(unsigned char row,unsigned char line){
	if ( row >= LCDROW ) row=0;
	if ( line >= LCDLINE ) line=0;


	lcdLine = line;
	lcdRow = row;


#if LCDLINE == 2
	if(line==1) row += 0x40;		// Pawdziwe dla wyswietlaczy 2 * x
#endif
#if LCDLINE == 4
	if(line==1) row += 0x40;		// Pawdziwe dla wyswietlaczy 4 * x
	if(line==2) row += LCDROW;		// Pawdziwe dla wyswietlaczy 4 * x
	if(line==3) row += 0x40+LCDROW;	// Pawdziwe dla wyswietlaczy 4 * x
#endif

#ifndef LCDIRQ
	row |= 0x80;					// Kod rozkazu ($80) OR pozycja w RAM LCD
	LcdSendCommand(row);
#endif
}


//-----------------------------------------------------------------
void LcdNextLine(){
	lcdRow = 0;
	if ( (++lcdLine) >= LCDLINE) lcdLine=0;
	LcdSetCursorPosition( lcdRow, lcdLine );
}


//-----------------------------------------------------------------
void LcdPrintChar(char character)
{
	//	LcdSendData( (character=LcdWin2Lcd( character )) );
#ifndef LCDIRQ
	LcdSendData( character  );
#endif

#if defined(LCDMIROR) || defined(LCDIRQ)
	LCDtabMiror[lcdLine][lcdRow] = character;
#endif


	if ( (++lcdRow) >= LCDROW){			// Po zapisaniu znaku Jesli przektroczono dlugosc wiersza to:
		if ( (++lcdLine) >= LCDLINE){	// Nastepny wiersz, jesli ostatni to:
			LcdHome();					// Wracamy na poczatek - "LcdHome()" zeruje "lcdRow" i "lcdLine"
		}
		switch(lcdLine)	{
		case(0): LcdSetCursorPosition(0,0); break;
		case(1): LcdSetCursorPosition(0,1); break;
		case(2): LcdSetCursorPosition(0,2); break;
		case(3): LcdSetCursorPosition(0,3); break;
		}
	}
}


void LcdPrintString(char *text)
{
	char znak;

	while (*text)	{				// Wyswietl tekst z RAMu
		znak = (*text);
		LcdPrintChar(znak);
		text++;
	}
}


void LcdInit(){
	extern TIM_HandleTypeDef htim7;
	HAL_TIM_Base_Start_IT(&htim7);

	HAL_GPIO_WritePin(D10_LIGHT_GPIO_Port, D10_LIGHT_Pin, GPIO_PIN_SET);


	LcdRSddr;								// Porty wyjsciami
#ifdef LCDRW
	LcdRWddr; LcdRWclr;	// todo: WR nieobslugiwane
#endif
	LcdEddr; LcdEclr; 						// E=0
	//	LcdDataOut();
	LcdRSclr;								// RS=0 (CMD)


	HAL_Delay(50);


	LcdRSclr;								// RS=0 (CMD)
	LcdSendNible(0x03); 					// Init magistrali 8-bit
	HAL_Delay(10);
	LcdSendNible(0x03); 					// Init magistrali 8-bit
	HAL_Delay(1);
	LcdSendNible(0x03); 					// Init magistrali 8-bit


#ifdef LCD8BIT
	LcdSendCommand(0x30); 					// Init magistrali 8-bit
	LcdSendCommand(0x38); 					// FunctionSet 	%0011_1000	(0  0  1 DL  N  F  -  -) DL=1 8bit, N=1 2lines, F=1 5*10dots
#else
	LcdSendNible(0x02); 				// Init magistrali 4-bit
	LcdSendCommand(0x28); 				// FunctionSet 	%0010_1000	(0  0  1 DL  N  F  -  -) DL=0 4bit, N=1 2lines, F=1 5*10dots
#endif

	LcdSendCommand(0x0C);					// DisplayOnOff	%0000_1100	(0  0  0  0  1  D  C  B) D-on/off, C-cursor on/of, B-blinking character
	LcdSendCommand(0x01);  					// DisplayClr	%0000_0001	(0  0  0  0  0  0  0  1)
	LcdSendCommand(0x06);					// EntryModeSet	%0000_0110	(0  0  0  0  0  1 ID  S) ID=1 increment, S=1

	LcdDispayOn();
	//	LcdLoadChar();
	LcdHome();								// "LcdHome()" zeruje "lcdRow" i "lcdLine"
	// oraz ustawia adres w DDRAM na 0
	// LCD OLED 100x32 WEG010016ALPP5N00000 (KAMAMI)
	// 											// Cursor/Display Shift		(0 0 0 1 SC RL 0 0 ) Scrolowanie ekranu/kursora
	// LcdSendCommand(0x1F);					//	Mode/ Pwr				(0 0 0 1 GC PWR 1 1 ) GC=0 tekst GC=1 grafika, PWR=1 On PWR=0 Off
	//
	// FunctionSet - dwa najmlodsze bity, zestaw znaków

	flLcdRun = true;
	LcdClr();
}


