/*
 * hd44780.h
 *
 *  Created on: Jan 26, 2022
 *      Author: PC
 */

#ifndef HD44780_H_
#define HD44780_H_


#define	LCDIRQ
//#define	LCD8BIT
#define	LCDMIROR


#define	LCDLINE	2			// Liczba wierszy
#define	LCDROW	16			// Liczba kolumn

#define	LcdRSddr
#define	LcdRSset		HAL_GPIO_WritePin(D8_RS_GPIO_Port, D8_RS_Pin, GPIO_PIN_SET)
#define	LcdRSclr		HAL_GPIO_WritePin(D8_RS_GPIO_Port, D8_RS_Pin, GPIO_PIN_RESET)
#define	LcdRS_Rd		HAL_GPIO_ReadPin(D8_RS_GPIO_Port, D8_RS_Pin)
#define	LcdEddr
#define	LcdEset			HAL_GPIO_WritePin(D9_E_GPIO_Port, D9_E_Pin, GPIO_PIN_SET)
#define	LcdEclr			HAL_GPIO_WritePin(D9_E_GPIO_Port, D9_E_Pin, GPIO_PIN_RESET)
#define	LcdD4ddr
#define	LcdD4set		HAL_GPIO_WritePin(D4_D4_GPIO_Port, D4_D4_Pin, GPIO_PIN_SET)
#define	LcdD4clr		HAL_GPIO_WritePin(D4_D4_GPIO_Port, D4_D4_Pin, GPIO_PIN_RESET)
#define	LcdD5ddr
#define	LcdD5set		HAL_GPIO_WritePin(D5_D5_GPIO_Port, D5_D5_Pin, GPIO_PIN_SET)
#define	LcdD5clr		HAL_GPIO_WritePin(D5_D5_GPIO_Port, D5_D5_Pin, GPIO_PIN_RESET)
#define	LcdD6ddr
#define	LcdD6set		HAL_GPIO_WritePin(D6_D6_GPIO_Port, D6_D6_Pin, GPIO_PIN_SET)
#define	LcdD6clr		HAL_GPIO_WritePin(D6_D6_GPIO_Port, D6_D6_Pin, GPIO_PIN_RESET)
#define	LcdD7ddr
#define	LcdD7set		HAL_GPIO_WritePin(D7_D7_GPIO_Port, D7_D7_Pin, GPIO_PIN_SET)
#define	LcdD7clr		HAL_GPIO_WritePin(D7_D7_GPIO_Port, D7_D7_Pin, GPIO_PIN_RESET)


#define	DELAYLCD	15		// 30 - KA-NUCLEO + Arduino LCD Keypad Shield


void LcdClr();
void LcdHome();
void LcdSendNible(unsigned char data);
void LcdSendData(unsigned char data);
void LcdSetCursorPosition(unsigned char row,unsigned char line);
void LcdNextLine();
void LcdSendCommand(unsigned char data);
void LcdPrintChar(char character);
void LcdPrintString(char *text);
void LcdInit();
void LcdSendData(unsigned char data);
void LcdSendData_IT(unsigned char data);
void LcdSendCommand(unsigned char data);
void LcdSendCommand_IT(unsigned char data);
void LcdSendNible(unsigned char data);
void LcdSendNible_IT(unsigned char data);


#define	LcdDispayOn()		LcdSendCommand(0xC)
#define	LcdDisplayOff()	LcdSendCommand(0x8)
#define	LcdCursorOn()  	LcdSendCommand(0xF)	// migajacy kursor (zanegowany kwadrat)
#define	LcdCursorOn_() 	LcdSendCommand(0xE)	// 0xE bez migania kursora
#define	LcdCursorOff() 	LcdSendCommand(0xC)


#endif /* HD44780_H_ */
