/* USER CODE BEGIN Header */
/**
 ******************************************************************************
 * @file           : main.c
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * Copyright (c) 2022 STMicroelectronics.
 * All rights reserved.
 *
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 * If no LICENSE file comes with this software, it is provided AS-IS.
 *
 ******************************************************************************
 */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "adc.h"
#include "dma.h"
#include "iwdg.h"
#include "tim.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

#include <string.h>
#include <stdio.h>

#include "../def.h"
#include "../ansi.h"
#include "../HD44780/hd44780.h"

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

//---------------------------------------------------------------------------//
//void irq1ms(){

uint8_t volatile timDeadKey = 255;
uint16_t volatile timKey, timSave, timRepeatKey, timRepeatKeyFast,timLcd = 5000;

void HAL_IncTick(void){
	uwTick += (uint32_t)uwTickFreq;


	//	HAL_GPIO_TogglePin(TEST_1MS_GPIO_Port, TEST_1MS_Pin);

	if( timRepeatKey ) timRepeatKey--;
	if( timRepeatKeyFast ) timRepeatKeyFast;
	if( timKey ) timKey--;
	if( timLcd ) timLcd--;
	if( timSave && timSave != UINT16_MAX ) timSave--;
	if( timDeadKey ) timDeadKey--;
}


void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim){
	if( htim == &htim7 ){
		extern void lcd_us();
		lcd_us();
	}
}


//---------------------------------------------------------------------------//
uint16_t volatile PomiarADC;
bool volatile FLadc = true;
void HAL_ADC_ConvCpltCallback(ADC_HandleTypeDef* hadc){
	PomiarADC = HAL_ADC_GetValue(hadc); // Pobranie zmierzonej wartosci
	FLadc = true;
	//	HAL_ADC_Start_IT(hadc);
}


enum key_t{KEY_NONE, KEY_R, KEY_UP, KEY_DW, KEY_L, KEY_SEL, KEY_TRESET} ;
key_t keyLcd;

#define	DEF_REPEAT_KEY			1000
#define	DEF_REPEAT_KEY_FAST		5000

key_t getKey(){
	key_t static prevKey;


	if ( ! timKey ){
		timKey = 10;
		key_t key = KEY_NONE;


		if( PomiarADC < 100 ) key = KEY_R;
		else if( PomiarADC > 500 && PomiarADC < 1000 ) key = KEY_UP;	//  65x
		else if( PomiarADC > 1100 && PomiarADC < 1400 ) key = KEY_DW;	// 128x
		else if( PomiarADC > 1500 && PomiarADC < 1900 ) key = KEY_L;	// 175x
		else if( PomiarADC > 2000 && PomiarADC < 2400 ) key = KEY_SEL;	// 224x


		//	uint8_t static cnt;
		//	if( ! HAL_GPIO_ReadPin(T_RESET_GPIO_Port, T_RESET_Pin) ){
		//		TRAP;
		//		if ( !timKeyInit ){
		//			timKeyInit = 5;
		//
		//			if( cnt < 10 ) cnt++; else return KEY_TRESET;
		//		}
		//	} else cnt = 0;


		if( ! key ){
			timRepeatKey = DEF_REPEAT_KEY; timRepeatKeyFast = DEF_REPEAT_KEY_FAST;		// Nienaciśnięty to "zeruj" repeat
		}


		if( prevKey != key ){	// jeśli kod różny od ostatniego
			prevKey = key;

			timRepeatKey = DEF_REPEAT_KEY; timRepeatKeyFast = DEF_REPEAT_KEY_FAST;	// "zeruj" repeat

			return key;				// zwróc kod

		}else{					// Klawisz przytrzymany
			if( ! timRepeatKeyFast ){
				timKey = 1;	// jeśli przetrzymany autopowtarzanie 1 ms
				return key;		// jesli naciśnięty zwróc kod
			}else if ( ! timRepeatKey ){
				timKey = 100;	// jeśli przetrzymany autopowtarzanie 100 ms
				return key;		// jesli naciśnięty zwróc kod
			}
		}


	}


	return KEY_NONE;
}


struct Pwm{
	uint32_t crc;
	uint32_t Period;
	uint32_t krokPrzestrajania;
	uint32_t CCR;
}Pwm;


//---------------------------------------------------------------------------//
#define EEPROM_BASE_ADDR	0x08080000
#define EEPROM_BYTE_SIZE	8192

void EEPROM_WRITE(uint16_t BiasAddress, uint8_t *Data, uint16_t len){
	uint16_t i;
	HAL_StatusTypeDef status = HAL_OK;

	HAL_FLASHEx_DATAEEPROM_Unlock();
	for(i=0;i<len;i++)	{
		status += HAL_FLASHEx_DATAEEPROM_Program(FLASH_TYPEPROGRAMDATA_BYTE, EEPROM_BASE_ADDR+BiasAddress+i, *Data);
		Data++;
	}
	HAL_FLASHEx_DATAEEPROM_Lock();
}

//---------------------------------------------------------------------------//
void EEPROM_READ(uint16_t BiasAddress, uint8_t *Buffer,uint16_t Len)
{
	uint8_t *wAddr;
	wAddr=(uint8_t *)(EEPROM_BASE_ADDR+BiasAddress);
	while(Len--){
		*Buffer++=*wAddr++;
	}
}



void set50procent(){
	if( Pwm.Period >=2 ){
		if( Pwm.Period & 1 ) Pwm.CCR = (Pwm.Period >> 1) + 1;
		else Pwm.CCR = Pwm.Period >> 1;
	}
	else Pwm.CCR = 1;
}


uint32_t liczCrc(){
	return Pwm.CCR ^ Pwm.Period ^ Pwm.krokPrzestrajania;
}


void setPwm(){
	TIM_HandleTypeDef *htim;
	htim = &htim2;

	htim->Instance->ARR = Pwm.Period;
	htim->Instance->CCR4 = Pwm.CCR;
}


/* USER CODE END 0 */

/**
 * @brief  The application entry point.
 * @retval int
 */
int main(void)
{
	/* USER CODE BEGIN 1 */


	//----- Zatrzymuj IWDG podczas debugowania -----//

	__HAL_DBGMCU_FREEZE_IWDG(); // DBGMCU -> APB1FZ |= DBGMCU_APB1_FZ_DBG_IWDG_STOP;
	__HAL_DBGMCU_FREEZE_WWDG();

	//----- Nie rozlaczaj z debugerem po usypieniu, stop, itp
	DBGMCU->CR |= DBGMCU_CR_DBG_SLEEP | DBGMCU_CR_DBG_STOP | DBGMCU_CR_DBG_STANDBY;   //


	// __HAL_DBGMCU_FREEZE_TIM1();
	// __HAL_DBGMCU_FREEZE_TIM6();



	/* USER CODE END 1 */

	/* MCU Configuration--------------------------------------------------------*/

	/* Reset of all peripherals, Initializes the Flash interface and the Systick. */
	HAL_Init();

	/* USER CODE BEGIN Init */

	/* USER CODE END Init */

	/* Configure the system clock */
	SystemClock_Config();

	/* USER CODE BEGIN SysInit */

	/* USER CODE END SysInit */

	/* Initialize all configured peripherals */
	MX_GPIO_Init();
	MX_DMA_Init();
	MX_USART2_UART_Init();
	MX_IWDG_Init();
	MX_TIM2_Init();
	MX_ADC_Init();
	MX_TIM7_Init();
	/* USER CODE BEGIN 2 */

	HAL_TIM_PWM_Start(&htim2, TIM_CHANNEL_4);


	LcdInit();
	//				0123456789abcdef
	LcdPrintString("Generator PWM");
	LcdSetCursorPosition(0,1);
	LcdPrintString("V1.0 "__DATE__);
	LcdSetCursorPosition(0, 0);


	EEPROM_READ( EEPROM_BASE_ADDR, (uint8_t*)&Pwm, sizeof(Pwm) );
	if( liczCrc() != Pwm.crc ){
		Pwm.Period = 31;		// 1MHz
		Pwm.CCR = 16;
		Pwm.krokPrzestrajania = 1;
	}
	setPwm();


	/* USER CODE END 2 */

	/* Infinite loop */
	/* USER CODE BEGIN WHILE */
	while (1)  {
		HAL_IWDG_Refresh(&hiwdg);
		__WFI();
		/* USER CODE END WHILE */

		/* USER CODE BEGIN 3 */

		if( FLadc ){
			FLadc = false;
			HAL_ADC_Start_IT(&hadc);
		}


		if ( (keyLcd = getKey()) && ! timDeadKey ){
			timLcd = 0;

			timSave = 10000;

			switch( keyLcd ){
			case KEY_UP:
				if( Pwm.Period > 1000-1 ){
					Pwm.krokPrzestrajania = 1000;
						Pwm.Period -= 1000;
				}else if( Pwm.Period > 100-1 ){
					Pwm.krokPrzestrajania = 100;
					Pwm.Period -= 100;
				}else if( Pwm.Period >= 2 ) {
					Pwm.krokPrzestrajania = 1;
					Pwm.Period--;
				}
				set50procent();
				break;
			case KEY_DW:
				if( Pwm.Period < 100-1 ) {
					Pwm.krokPrzestrajania = 1;
					Pwm.Period++;
				}else if ( Pwm.Period < 1000-1 ) {
					Pwm.krokPrzestrajania = 100;
					Pwm.Period += 100;
				}else{
					Pwm.krokPrzestrajania = 1000;
					if( Pwm.Period < 64000-1 ) 	Pwm.Period += 1000;		//Min 500 Hz (wL152 Timer2 jest 16-bit a nie 32
				}
				set50procent();
				break;
			case KEY_L:
				TRAP;
				if( Pwm.CCR >= 2 ) Pwm.CCR -= Pwm.krokPrzestrajania;
				TRAP;
				break;
			case KEY_R:
				TRAP;
				if( Pwm.CCR < Pwm.Period ) Pwm.CCR += Pwm.krokPrzestrajania;
				TRAP;
				break;
			}

			setPwm();
		}


		if( ! timSave ){
			timSave = UINT16_MAX;

			 Pwm.crc = liczCrc();
			EEPROM_WRITE( EEPROM_BASE_ADDR, (uint8_t*)&Pwm, sizeof(Pwm) );
		}


		if ( ! timLcd ){
			timLcd = 100;

			char txt[30];
			uint32_t f = 32e6/(Pwm.Period+1);
			uint32_t fm = 32e9/(Pwm.Period+1);
			uint32_t fMHz = f / 1e6;
			uint32_t fk = f - fMHz * 1e6;
			uint32_t fkHz = fk / 1000;
			uint16_t fHz = fk % 1000;
			uint16_t fmHz = fm % 1000;

			uint32_t duty = Pwm.CCR * 10000 / (Pwm.Period+1);

			//LcdClr();
			if( f >= 1e6 ) sprintf(txt, "f %2lu,%03lu'%03u MHz", fMHz, fkHz, fHz );
			else if ( f >= 1000 ) sprintf(txt, "f=   %3lu,%03u kHz", fkHz, fHz );
			else sprintf(txt, "f=       %3u,%03u Hz", (uint32_t)fHz, (uint32_t)fmHz );
			//		else sprintf(txt, "         %03lumHz  ", (uint32_t)fmHz );



			LcdSetCursorPosition(0, 0);
			LcdPrintString(txt);
			sprintf(txt, "Duty %2lu,%02lu%%    ", duty / 100, duty % 100);
			LcdSetCursorPosition(0, 1);
			if( timSave != UINT16_MAX ) strcat( txt, "*" );	else  strcat( txt, " " );
			LcdPrintString(txt);

		}
	}
	/* USER CODE END 3 */
}

/**
 * @brief System Clock Configuration
 * @retval None
 */
void SystemClock_Config(void)
{
	RCC_OscInitTypeDef RCC_OscInitStruct = {0};
	RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

	/** Configure the main internal regulator output voltage
	 */
	__HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

	/** Initializes the RCC Oscillators according to the specified parameters
	 * in the RCC_OscInitTypeDef structure.
	 */
	RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI|RCC_OSCILLATORTYPE_LSI;
	RCC_OscInitStruct.HSIState = RCC_HSI_ON;
	RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
	RCC_OscInitStruct.LSIState = RCC_LSI_ON;
	RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
	RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI;
	RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL6;
	RCC_OscInitStruct.PLL.PLLDIV = RCC_PLL_DIV3;
	if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
	{
		Error_Handler();
	}

	/** Initializes the CPU, AHB and APB buses clocks
	 */
	RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
			|RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
	RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
	RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
	RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;
	RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

	if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_1) != HAL_OK)
	{
		Error_Handler();
	}
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
 * @brief  This function is executed in case of error occurrence.
 * @retval None
 */
void Error_Handler(void)
{
	/* USER CODE BEGIN Error_Handler_Debug */
	/* User can add his own implementation to report the HAL error return state */
	__disable_irq();
	while (1)
	{
	}
	/* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
 * @brief  Reports the name of the source file and the source line number
 *         where the assert_param error has occurred.
 * @param  file: pointer to the source file name
 * @param  line: assert_param error line source number
 * @retval None
 */
void assert_failed(uint8_t *file, uint32_t line)
{
	/* USER CODE BEGIN 6 */
	/* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	/* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
